// FIFO inspired by article at
// https://blog.stratifylabs.co/device/2013-10-02-A-FIFO-Buffer-Implementation/

// Depends on availability of 64bit off_t otherwise stream length is limited 2GB. 
#define FIFO_STREAM_LENGTH 200000000000

fifo_t * my_fifo;
char fifo_buffer[FIFO_BUFFER_SIZE];
pthread_mutex_t mutex1;

// Initialisation
void fifo_init(fifo_t * f, char * url, int upnp_id);

// Read nbytes bytes from the FIFO. Return the number of bytes read
int fifo_read(fifo_t * f, void * buf, int nbytes);

// Write nbytes bytes to the FIFO. The number of bytes written is returned
//If the head runs in to the tail, not all bytes are written
int fifo_write(fifo_t * f, const void * buf, int nbytes);

// Read stream and put it in the FIFO
void * ReadStream(void * param);

// Access the buffer to read it, pass data out for other uses
int AccessFIFO(fifo_t * f, char *buf, int buflen);

//Get properties of MP3 data in the FIFO
int fifo_frames(fifo_t * f);

